Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90	(revision 2528)
@@ -1167,46 +431,57 @@
       !!      called explicitly before cpl_prism_init it will also close
       !!      MPI communication.
-      !!
-      !! ** Method  : OASIS4
       !!----------------------------------------------------------------------
 
       DEALLOCATE(exfld)
-
-      if ( prism_was_initialized ) then
-
-         call prism_terminated ( prism_was_terminated, ierror )
-         
-         if ( prism_was_terminated ) then
-            print *, 'prism has already been terminated.'
-         else
-            call prism_terminate ( ierror )
-            prism_was_terminated = .true.
-         endif
-
-      else
-
-         print *, 'Initialize prism before terminating it.'
-
-      endif
-
+      CALL prism_terminate ( nerror )         
 
    END SUBROUTINE cpl_prism_finalize
 
-#else
-
-   !!----------------------------------------------------------------------
-   !!   Default case           Dummy module         forced Ocean/Atmosphere
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE cpl_prism_init             ! Dummy routine
-   END SUBROUTINE cpl_prism_init
-   SUBROUTINE cpl_prism_define           ! Dummy routine
-   END SUBROUTINE cpl_prism_define
-   SUBROUTINE cpl_prism_send             ! Dummy routine
-   END SUBROUTINE cpl_prism_send
-   SUBROUTINE cpl_prism_recv             ! Dummy routine
-   END SUBROUTINE cpl_prism_recv
-   SUBROUTINE cpl_prism_finalize         ! Dummy routine
-   END SUBROUTINE cpl_prism_finalize
+   SUBROUTINE cpl_prism_update_time(kt)
+
+      !!---------------------------------------------------------------------
+      !!              ***  ROUTINE cpl_prism_update_time  ***
+      !!
+      !! ** Purpose : - Increment date with model timestep
+      !!      called explicitly at the end of each timestep
+      !!----------------------------------------------------------------------
+
+      INTEGER, INTENT(in) ::   kt       ! ocean model time step index
+
+      TYPE(PRISM_Time_struct)    :: tmpdate
+      INTEGER                    :: idate_incr     ! date increment
+
+
+      IF( kt == nit000 ) THEN
+      !
+      ! Define the actual date 
+      !
+      ! date is determined by adding days since beginning of the run to the corresponding initial date.
+      ! Note that OPA internal info about the start date of the experiment is bypassed.
+      ! Instead we rely sololy on the info provided by the SCC.xml file.
+      !
+         date = PRISM_Jobstart_date
+         !
+         !
+         ! lower/upper bound is determined by adding half a time step
+         !
+         idate_incr = 0.5 * NINT ( rdttra(1) )
+         tmpdate = date   ;   CALL PRISM_calc_newdate ( tmpdate, -idate_incr, nerror )   ;   date_bound(1) = tmpdate
+         tmpdate = date   ;   CALL PRISM_calc_newdate ( tmpdate,  idate_incr, nerror )   ;   date_bound(2) = tmpdate
+
+      ELSE
+      !
+      ! Date update
+      !
+         idate_incr  = rdttra(1)
+         CALL PRISM_calc_newdate( date, idate_incr, nerror )
+         date_bound(1) = date_bound(2)
+         tmpdate = date_bound(2)
+         CALL PRISM_calc_newdate( tmpdate, idate_incr, nerror )
+         date_bound(2) = tmpdate
+
+      END IF
+
+   END SUBROUTINE cpl_prism_update_time
 
 #endif
Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/fldread.F90	(revision 2528)
@@ -15,4 +15,5 @@
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
+   USE ioipsl, ONLY :   ymds2ju, ju2ymds   ! for calendar
    USE phycst          ! ???
    USE in_out_manager  ! I/O manager
@@ -29,9 +30,9 @@
       LOGICAL              ::   ln_tint     ! time interpolation or not (T/F)
       LOGICAL              ::   ln_clim     ! climatology or not (T/F)
-      CHARACTER(len = 7)   ::   cltype      ! type of data file 'daily', 'monthly' or yearly'
+      CHARACTER(len = 8)   ::   cltype      ! type of data file 'daily', 'monthly' or yearly'
       CHARACTER(len = 34)  ::   wname       ! generic name of a NetCDF weights file to be used, blank if not
       CHARACTER(len = 34)  ::   vcomp       ! symbolic component name if a vector that needs rotation
-                                           ! a string starting with "U" or "V" for each component   
-                                           ! chars 2 onwards identify which components go together  
+                                            ! a string starting with "U" or "V" for each component   
+                                            ! chars 2 onwards identify which components go together  
    END TYPE FLD_N
 
@@ -43,15 +44,14 @@
       LOGICAL                         ::   ln_tint      ! time interpolation or not (T/F)
       LOGICAL                         ::   ln_clim      ! climatology or not (T/F)
-      CHARACTER(len = 7)              ::   cltype       ! type of data file 'daily', 'monthly' or yearly'
+      CHARACTER(len = 8)              ::   cltype       ! type of data file 'daily', 'monthly' or yearly'
       INTEGER                         ::   num          ! iom id of the jpfld files to be read
-      INTEGER                         ::   nswap_sec    ! swapping time in second since Jan. 1st 00h of nit000 year
       INTEGER , DIMENSION(2)          ::   nrec_b       ! before record (1: index, 2: second since Jan. 1st 00h of nit000 year)
       INTEGER , DIMENSION(2)          ::   nrec_a       ! after  record (1: index, 2: second since Jan. 1st 00h of nit000 year)
-      REAL(wp) , ALLOCATABLE, DIMENSION(:,:)   ::   fnow         ! input fields interpolated to now time step
-      REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:) ::   fdta         ! 2 consecutive record of input fields
+      REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:  ) ::   fnow       ! input fields interpolated to now time step
+      REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:,:) ::   fdta       ! 2 consecutive record of input fields
       CHARACTER(len = 256)            ::   wgtname      ! current name of the NetCDF weight file acting as a key
                                                         ! into the WGTLIST structure
       CHARACTER(len = 34)             ::   vcomp        ! symbolic name for a vector component that needs rotation
-      LOGICAL ,  DIMENSION(2)         ::   rotn         ! flag to indicate whether field has been rotated
+      LOGICAL                         ::   rotn         ! flag to indicate whether field has been rotated
    END TYPE FLD
 
@@ -71,13 +71,13 @@
       INTEGER                                 ::   numwgt       ! number of weights (4=bilinear, 16=bicubic)
       INTEGER                                 ::   nestid       ! for agrif, keep track of nest we're in
-      INTEGER                                 ::   offset       ! =0 when cyclic grid has coincident first/last columns, 
-                                                                ! =1 when they assumed to be one grid spacing apart      
-                                                                ! =-1 otherwise
+      INTEGER                                 ::   overlap      ! =0 when cyclic grid has no overlapping EW columns
+                                                                ! =>1 when they have one or more overlapping columns      
+                                                                ! =-1 not cyclic
       LOGICAL                                 ::   cyclic       ! east-west cyclic or not
-      INTEGER, DIMENSION(:,:,:), POINTER      ::   data_jpi     ! array of source integers
-      INTEGER, DIMENSION(:,:,:), POINTER      ::   data_jpj     ! array of source integers
+      INTEGER,  DIMENSION(:,:,:), POINTER     ::   data_jpi     ! array of source integers
+      INTEGER,  DIMENSION(:,:,:), POINTER     ::   data_jpj     ! array of source integers
       REAL(wp), DIMENSION(:,:,:), POINTER     ::   data_wgt     ! array of weights on model grid
-      REAL(wp), DIMENSION(:,:), POINTER       ::   fly_dta      ! array of values on input grid
-      REAL(wp), DIMENSION(:,:), POINTER       ::   col2         ! temporary array for reading in columns
+      REAL(wp), DIMENSION(:,:,:), POINTER     ::   fly_dta      ! array of values on input grid
+      REAL(wp), DIMENSION(:,:,:), POINTER     ::   col          ! temporary array for reading in columns
    END TYPE WGT
 
@@ -91,7 +91,7 @@
 
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -114,11 +114,6 @@
       TYPE(FLD), INTENT(inout), DIMENSION(:) ::   sd        ! input field related variables
       !!
-      CHARACTER (LEN=34)                     ::   acomp     ! dummy weight name
-      INTEGER                                ::   kf, nf    ! dummy indices
-      INTEGER                                ::   imf       ! size of the structure sd
-      REAL(wp), DIMENSION(jpi,jpj)           ::   utmp, vtmp! temporary arrays for vector rotation
-
+      INTEGER  ::   imf        ! size of the structure sd
       INTEGER  ::   jf         ! dummy indices
-      INTEGER  ::   kw         ! index into wgts array
       INTEGER  ::   ireclast   ! last record to be read in the current year file
       INTEGER  ::   isecend    ! number of second since Jan. 1st 00h of nit000 year at nitend
@@ -131,175 +126,128 @@
       CHARACTER(LEN=1000) ::   clfmt   ! write format
       !!---------------------------------------------------------------------
-      !
+      ! Note that shifting time to be centrered in the middle of sbc time step impacts only nsec_* variables of the calendar 
+      isecsbc = nsec_year + nsec1jan000 + NINT(0.5 * REAL(kn_fsbc - 1,wp) * rdttra(1))   ! middle of sbc time step
       imf = SIZE( sd )
-      isecsbc = nsec_year + nsec1jan000 + NINT(0.5 * REAL(kn_fsbc - 1,wp) * rdttra(1))   ! centrered in the middle of sbc time step
-      !
-      !                                         ! ===================== !
-      DO jf = 1, imf                            !    LOOP OVER FIELD    !
-         !                                      ! ===================== !
-         !
-         IF( kt == nit000 )   CALL fld_init( kn_fsbc, sd(jf) )
-         !
-         ! read/update the after data?
-         IF( isecsbc > sd(jf)%nswap_sec ) THEN 
-
-            IF( sd(jf)%ln_tint ) THEN         ! time interpolation: swap before record field
+      !
+      IF( kt == nit000 ) THEN                      ! initialization
+         DO jf = 1, imf 
+            CALL fld_init( kn_fsbc, sd(jf) )       ! read each before field (put them in after as they will be swapped)
+         END DO
+         IF( lwp ) CALL wgt_print()                ! control print
+         CALL fld_rot( kt, sd )                    ! rotate vector fiels if needed
+      ENDIF
+      !                                            ! ====================================== !
+      IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN         ! update field at each kn_fsbc time-step !
+         !                                         ! ====================================== !
+         !
+         DO jf = 1, imf                            ! ---   loop over field   --- !
+            
+            IF( isecsbc > sd(jf)%nrec_a(2) .OR. kt == nit000 ) THEN  ! read/update the after data?
+
+               IF( sd(jf)%ln_tint ) THEN                             ! swap before record field and informations
+                  sd(jf)%nrec_b(:) = sd(jf)%nrec_a(:)
 !CDIR COLLAPSE
-               sd(jf)%fdta(:,:,1) = sd(jf)%fdta(:,:,2)
-               sd(jf)%rotn(1)     = sd(jf)%rotn(2)
+                  sd(jf)%fdta(:,:,:,1) = sd(jf)%fdta(:,:,:,2)
+               ENDIF
+
+               CALL fld_rec( kn_fsbc, sd(jf) )                       ! update record informations
+
+               ! do we have to change the year/month/week/day of the forcing field?? 
+               IF( sd(jf)%ln_tint ) THEN
+                  ! if we do time interpolation we will need to open next year/month/week/day file before the end of the current
+                  ! one. If so, we are still before the end of the year/month/week/day when calling fld_rec so sd(jf)%nrec_a(1)
+                  ! will be larger than the record number that should be read for current year/month/week/day
+
+                  ! last record to be read in the current file
+                  IF    ( sd(jf)%nfreqh == -12 ) THEN                 ;   ireclast = 1    !  yearly mean
+                  ELSEIF( sd(jf)%nfreqh ==  -1 ) THEN                                     ! monthly mean
+                     IF(     sd(jf)%cltype      == 'monthly' ) THEN   ;   ireclast = 1
+                     ELSE                                             ;   ireclast = 12
+                     ENDIF
+                  ELSE                                                                    ! higher frequency mean (in hours)
+                     IF(     sd(jf)%cltype      == 'monthly' ) THEN   ;   ireclast = 24 * nmonth_len(nmonth) / sd(jf)%nfreqh 
+                     ELSEIF( sd(jf)%cltype(1:4) == 'week'    ) THEN   ;   ireclast = 24 * 7                  / sd(jf)%nfreqh
+                     ELSEIF( sd(jf)%cltype      == 'daily'   ) THEN   ;   ireclast = 24                      / sd(jf)%nfreqh
+                     ELSE                                             ;   ireclast = 24 * nyear_len(     1 ) / sd(jf)%nfreqh 
+                     ENDIF
+                  ENDIF
+
+                  ! do we need next file data?
+                  IF( sd(jf)%nrec_a(1) > ireclast ) THEN
+
+                     sd(jf)%nrec_a(1) = 1              ! force to read the first record of the next file
+
+                     IF( .NOT. sd(jf)%ln_clim ) THEN   ! close the current file and open a new one.
+
+                        llnxtmth = sd(jf)%cltype == 'monthly' .OR. nday == nmonth_len(nmonth)      ! open next month file?
+                        llnxtyr  = sd(jf)%cltype == 'yearly'  .OR. (nmonth == 12 .AND. llnxtmth)   ! open next year  file?
+
+                        ! if the run finishes at the end of the current year/month/week/day, we will allow next
+                        ! year/month/week/day file to be not present. If the run continue further than the current
+                        ! year/month/week/day, next year/month/week/day file must exist
+                        isecend = nsec_year + nsec1jan000 + (nitend - kt) * NINT(rdttra(1))   ! second at the end of the run 
+                        llstop = isecend > sd(jf)%nrec_a(2)                                   ! read more than 1 record of next year
+
+                        CALL fld_clopn( sd(jf), nyear  + COUNT((/llnxtyr /))                                           ,         &
+                           &                    nmonth + COUNT((/llnxtmth/)) - 12                 * COUNT((/llnxtyr /)),         &
+                           &                    nday   + 1                   - nmonth_len(nmonth) * COUNT((/llnxtmth/)), llstop )
+
+                        IF( sd(jf)%num <= 0 .AND. .NOT. llstop ) THEN    ! next year file does not exist
+                           CALL ctl_warn('next year/month/week/day file: '//TRIM(sd(jf)%clname)//     &
+                              &     ' not present -> back to current year/month/day')
+                           CALL fld_clopn( sd(jf), nyear, nmonth, nday )       ! back to the current year/month/day
+                           sd(jf)%nrec_a(1) = ireclast     ! force to read the last record to be read in the current year file
+                        ENDIF
+
+                     ENDIF
+                  ENDIF
+
+               ELSE
+                  ! if we are not doing time interpolation, we must change the year/month/week/day of the file just after
+                  ! switching to the NEW year/month/week/day. If it is the case, we are at the beginning of the
+                  ! year/month/week/day when calling fld_rec so sd(jf)%nrec_a(1) = 1
+                  IF( sd(jf)%nrec_a(1) == 1 .AND. .NOT. ( sd(jf)%ln_clim .AND. sd(jf)%cltype == 'yearly' ) )   &
+                     &   CALL fld_clopn( sd(jf), nyear, nmonth, nday )
+               ENDIF
+
+               ! read after data
+               CALL fld_get( sd(jf) )
+
             ENDIF
-
-            ! update record informations
-            CALL fld_rec( kn_fsbc, sd(jf) )
-
-            ! do we have to change the year/month/day of the forcing field?? 
-            IF( sd(jf)%ln_tint ) THEN
-               ! if we do time interpolation we will need to open next year/month/day file before the end of the current one
-               ! if so, we are still before the end of the year/month/day when calling fld_rec so sd(jf)%nrec_a(1) will be
-               ! larger than the record number that should be read for current year/month/day (for ex. 13 for monthly mean file)
-
-               ! last record to be read in the current file
-               IF( sd(jf)%nfreqh == -1 ) THEN                  ;   ireclast = 12
-               ELSE                             
-                  IF(     sd(jf)%cltype == 'monthly'   ) THEN  ;   ireclast = 24 * nmonth_len(nmonth) / sd(jf)%nfreqh 
-                  ELSEIF( sd(jf)%cltype == 'daily'     ) THEN  ;   ireclast = 24                      / sd(jf)%nfreqh
-                  ELSE                                         ;   ireclast = 24 * nyear_len(     1 ) / sd(jf)%nfreqh 
-                  ENDIF
-               ENDIF
-              
-               ! do we need next file data?
-               IF( sd(jf)%nrec_a(1) > ireclast ) THEN
-
-                  sd(jf)%nrec_a(1) = 1              ! force to read the first record of the next file
-
-                  IF( .NOT. sd(jf)%ln_clim ) THEN   ! close the current file and open a new one.
-
-                     llnxtmth = sd(jf)%cltype == 'monthly' .OR. nday == nmonth_len(nmonth)      ! open next month file?
-                     llnxtyr  = sd(jf)%cltype == 'yearly'  .OR. (nmonth == 12 .AND. llnxtmth)   ! open next year  file?
-
-                     ! if the run finishes at the end of the current year/month/day, we will allow next year/month/day file to be
-                     ! not present. If the run continue further than the current year/month/day, next year/month/day file must exist
-                     isecend = nsec_year + nsec1jan000 + (nitend - kt) * NINT(rdttra(1))   ! second at the end of the run 
-                     llstop = isecend > sd(jf)%nswap_sec                                   ! read more than 1 record of next year
-
-                     CALL fld_clopn( sd(jf), nyear  + COUNT((/llnxtyr /))                                           ,         &
-                        &                    nmonth + COUNT((/llnxtmth/)) - 12                 * COUNT((/llnxtyr /)),         &
-                        &                    nday   + 1                   - nmonth_len(nmonth) * COUNT((/llnxtmth/)), llstop )
-
-                     IF( sd(jf)%num <= 0 .AND. .NOT. llstop ) THEN    ! next year file does not exist
-                        CALL ctl_warn('next year/month/day file: '//TRIM(sd(jf)%clname)//     &
-                                &     ' not present -> back to current year/month/day')
-                        CALL fld_clopn( sd(jf), nyear, nmonth, nday )       ! back to the current year/month/day
-                        sd(jf)%nrec_a(1) = ireclast     ! force to read the last record to be read in the current year file
-                     ENDIF
-
-                  ENDIF 
-               ENDIF
-        
-            ELSE
-               ! if we are not doing time interpolation, we must change the year/month/day of the file just after switching
-               ! to the NEW year/month/day. If it is the case, we are at the beginning of the year/month/day when calling 
-               ! fld_rec so sd(jf)%nrec_a(1) = 1
-               IF( sd(jf)%nrec_a(1) == 1 .AND. .NOT. sd(jf)%ln_clim )   CALL fld_clopn( sd(jf), nyear, nmonth, nday )
-            ENDIF
-
-            ! read after data
-            IF( LEN(TRIM(sd(jf)%wgtname)) > 0 ) THEN
-               CALL wgt_list( sd(jf), kw )
-               CALL fld_interp( sd(jf)%num, sd(jf)%clvar, kw, sd(jf)%fdta(:,:,2), sd(jf)%nrec_a(1) )
-            ELSE
-               CALL iom_get( sd(jf)%num, jpdom_data, sd(jf)%clvar, sd(jf)%fdta(:,:,2), sd(jf)%nrec_a(1) )
-            ENDIF
-            sd(jf)%rotn(2) = .FALSE.
-
-         ENDIF
-         !                                      ! ===================== !
-      END DO                                    !  END LOOP OVER FIELD  !
-      !                                         ! ===================== !
-
-      IF( kt == nit000 .AND. lwp ) CALL wgt_print()
-
-      !! Vector fields may need to be rotated onto the local grid direction
-      !! This has to happen before the time interpolations
-      !! (sga: following code should be modified so that pairs arent searched for each time
-
-      DO jf = 1, imf
-         !! find vector rotations required 
-         IF( LEN(TRIM(sd(jf)%vcomp)) > 0 ) THEN
-             !! east-west component has symbolic name starting with 'U'
-             IF( sd(jf)%vcomp(1:1) == 'U' ) THEN
-                !! found an east-west component, look for the north-south component
-                !! which has same symbolic name but with 'U' replaced with 'V'
-                nf = LEN_TRIM( sd(jf)%vcomp )
-                IF( nf == 1) THEN
-                   acomp = 'V'
-                ELSE
-                   acomp = 'V' // sd(jf)%vcomp(2:nf)
-                ENDIF
-                kf = -1
-                DO nf = 1, imf
-                  IF( TRIM(sd(nf)%vcomp) == TRIM(acomp) ) kf = nf
-                END DO
-                IF( kf > 0 ) THEN
-                   !! fields jf,kf are two components which need to be rotated together
-                   DO nf = 1,2
-                      !! check each time level of this pair
-                      IF( .NOT. sd(jf)%rotn(nf) .AND. .NOT. sd(kf)%rotn(nf) ) THEN
-                         utmp(:,:) = 0.0
-                         vtmp(:,:) = 0.0
-                         CALL rot_rep( sd(jf)%fdta(:,:,nf), sd(kf)%fdta(:,:,nf), 'T', 'en->i', utmp(:,:) )
-                         CALL rot_rep( sd(jf)%fdta(:,:,nf), sd(kf)%fdta(:,:,nf), 'T', 'en->j', vtmp(:,:) )
-                         sd(jf)%fdta(:,:,nf) = utmp(:,:)
-                         sd(kf)%fdta(:,:,nf) = vtmp(:,:)
-                         sd(jf)%rotn(nf) = .TRUE.
-                         sd(kf)%rotn(nf) = .TRUE.
-                         IF( lwp .AND. kt == nit000 ) &
-                                   WRITE(numout,*) 'fld_read: vector pair (',  &
-                                                   TRIM(sd(jf)%clvar),',',TRIM(sd(kf)%clvar), &
-                                                   ') rotated on to model grid'
-                      ENDIF
-                   END DO
-                ENDIF
-             ENDIF
-         ENDIF
-      END DO
-
-      !                                         ! ===================== !
-      DO jf = 1, imf                            !    LOOP OVER FIELD    !
-         !                                      ! ===================== !
-         !
-         ! update field at each kn_fsbc time-step
-         IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN   
+         END DO                                    ! --- end loop over field --- !
+
+         CALL fld_rot( kt, sd )                    ! rotate vector fiels if needed
+
+         DO jf = 1, imf                            ! ---   loop over field   --- !
             !
-            IF( sd(jf)%ln_tint ) THEN
+            IF( sd(jf)%ln_tint ) THEN              ! temporal interpolation
                IF(lwp .AND. kt - nit000 <= 100 ) THEN 
-                  clfmt = "('fld_read: var ', a, ' kt = ', i8,' Y/M/D = ', i4.4,'/', i2.2,'/', i2.2," //   &
-                     &    "' records b/a: ', i4.4, '/', i4.4, ' (', f7.2,'/', f7.2, ' days)')"
-                  WRITE(numout, clfmt)  TRIM( sd(jf)%clvar ), kt, nyear, nmonth, nday,   &
+                  clfmt = "('fld_read: var ', a, ' kt = ', i8, ' (', f7.2,' days), Y/M/D = ', i4.4,'/', i2.2,'/', i2.2," //   &
+                     &    "', records b/a: ', i4.4, '/', i4.4, ' (days ', f7.2,'/', f7.2, ')')"
+                  WRITE(numout, clfmt)  TRIM( sd(jf)%clvar ), kt, REAL(isecsbc,wp)/rday, nyear, nmonth, nday,   &
                      & sd(jf)%nrec_b(1), sd(jf)%nrec_a(1), REAL(sd(jf)%nrec_b(2),wp)/rday, REAL(sd(jf)%nrec_a(2),wp)/rday
                ENDIF
-               !
+               ! temporal interpolation weights
                ztinta =  REAL( isecsbc - sd(jf)%nrec_b(2), wp ) / REAL( sd(jf)%nrec_a(2) - sd(jf)%nrec_b(2), wp )
                ztintb =  1. - ztinta
 !CDIR COLLAPSE
-               sd(jf)%fnow(:,:) = ztintb * sd(jf)%fdta(:,:,1) + ztinta * sd(jf)%fdta(:,:,2)
-            ELSE
+               sd(jf)%fnow(:,:,:) = ztintb * sd(jf)%fdta(:,:,:,1) + ztinta * sd(jf)%fdta(:,:,:,2)
+            ELSE   ! nothing to do...
                IF(lwp .AND. kt - nit000 <= 100 ) THEN
-                  clfmt = "('fld_read: var ', a, ' kt = ', i8,' Y/M/D = ', i4.4,'/', i2.2,'/', i2.2," //   &
-                     &    "' record: ', i4.4, ' at ', f7.2, ' day')"
-                  WRITE(numout, clfmt) TRIM(sd(jf)%clvar), kt, nyear, nmonth, nday, sd(jf)%nrec_a(1), REAL(sd(jf)%nrec_a(2),wp)/rday
+                  clfmt = "('fld_read: var ', a, ' kt = ', i8,' (', f7.2,' days), Y/M/D = ', i4.4,'/', i2.2,'/', i2.2," //   &
+                     &    "', record: ', i4.4, ' (days ', f7.2, ' <-> ', f7.2, ')')"
+                  WRITE(numout, clfmt) TRIM(sd(jf)%clvar), kt, REAL(isecsbc,wp)/rday, nyear, nmonth, nday,    &
+                     &                 sd(jf)%nrec_a(1), REAL(sd(jf)%nrec_b(2),wp)/rday, REAL(sd(jf)%nrec_a(2),wp)/rday
                ENDIF
-!CDIR COLLAPSE
-               sd(jf)%fnow(:,:) = sd(jf)%fdta(:,:,2)   ! piecewise constant field
- 
             ENDIF
             !
-         ENDIF
-
-         IF( kt == nitend )   CALL iom_close( sd(jf)%num )   ! Close the input files
-
-         !                                      ! ===================== !
-      END DO                                    !  END LOOP OVER FIELD  !
-      !                                         ! ===================== !
+            IF( kt == nitend - kn_fsbc + 1 )   CALL iom_close( sd(jf)%num )   ! Close the input files
+
+         END DO                                    ! --- end loop over field --- !
+         !
+         !                                         ! ====================================== !
+      ENDIF                                        ! update field at each kn_fsbc time-step !
+      !                                            ! ====================================== !
+      !
    END SUBROUTINE fld_read
 
